'''
COPYRIGHT LICENSE:  This utility is owned by IBM and is provided in source code form. 
You may copy and use (but not modify)  the utility  without payment to IBM for the 
purposes of helping you to migrate your data from an IBM Workload Deployer product to
another IBM product. Notwithstanding anything to the contrary,  IBM PROVIDES THE UTILITY
ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING,
BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY, SATISFACTORY
QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND ANY WARRANTY OR CONDITION OF
NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR OPERATION OF THE UTLITY.  
IBM MAY PROVIDE LIMITED SUPPORTFOR THE UTLITY, BUT IBM HAS NO OBLIGATION TO PROVIDE
MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE UTLITITY.
'''

import codecs
import getopt
import sys
import os
import time
from deployer import patternloader
from scomigrator import virtual_images, migration_exceptions
	
def checkoutImages(options):
	print "Checking out images available on VIL\n" 
	print "--------------------------------------------\n"
	isError = 0
	timestamp = time.strftime("%m-%d_%H%M%S", time.localtime())
	logFile = "checkout_" + timestamp + ".log"
	tmpStdout = sys.stdout
	tmpStderr = sys.stderr
	try:
		f = initLog(logFile)
		isError = virtual_images.checkOutVirtualImages(options['sco_hostname'], options['vmware_repository'], options['vmware_datastore'], options['sco_user'], options['sco_password'])			
		f.close()
		sys.stdout = tmpStdout
	except Exception, err:
		migration_exceptions.printGeneralException(err)
		isError = 1
	finally:
		f.close()
		sys.stdout = tmpStdout
		sys.stderr = tmpStderr
		
	print "--------------------------------------------"
	if isError :
		print "Check Out of virtual images run with errors\n"
	else:
		print "Check Out of virtual images scheduled."
		print "To ensure if completed successfully login to VIL UI and check the operation progress.\n"
		
def initLog(logFile):
	currentDir = os.path.dirname(os.path.realpath(sys.argv[0]))
	logDir = currentDir + "/logs"
	if not os.path.exists(logDir):
		os.makedirs(logDir)
	logFileFqp = logDir + "/" + logFile  
	print "Writing output to : %s\n" % (logFileFqp)
	f = open(logFileFqp,'w')
	sys.stdout = f
	sys.stderr = sys.stdout
	return f

options = None
try:
    (params, args) = getopt.getopt(sys.argv[1:], 'd:', [ 'data='])
except getopt.GetoptError:
    help()

for param in params:
	if param[0] == '-d' or param[0] == '--data':
		options = patternloader._parseJSON(param[1])

if options == None:
	print "Required attributes was not specified. Exiting"
	sys.exit(1)

checkoutImages(options)


		
	