#!/bin/bash

############################################################################################
# COPYRIGHT LICENSE:  This utility is owned by IBM and is provided in source code form. 
# You may copy and use (but not modify)  the utility  without payment to IBM for the 
# purposes of helping you to migrate your data from an IBM Workload Deployer product to
# another IBM product. Notwithstanding anything to the contrary,  IBM PROVIDES THE UTILITY
# ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING,
# BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY, SATISFACTORY
# QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND ANY WARRANTY OR CONDITION OF
# NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL
# OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR OPERATION OF THE UTLITY.  
# IBM MAY PROVIDE LIMITED SUPPORTFOR THE UTLITY, BUT IBM HAS NO OBLIGATION TO PROVIDE
# MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE UTLITITY.
###########################################################################################

CURRENT_DIR=$(dirname "$0")
COMMONS="$CURRENT_DIR/../commons.sh"
if [ ! -f $COMMONS ] ; then
	echo "Wrong path to script commons.sh. Path: $COMMONS. Tool cannot continue"
	exit 2
fi

source $COMMONS

DATA_FILE="$CURRENT_DIR/checkout_data.txt"
CHECKOUT_FILE="$CURRENT_DIR/checkout.py"

while [ $# -gt 0 ]
do
	if [ -z "$2" ] ; then
    	echo "No argument supplied for option $1. Exiting the script."
    	exit 2
	fi
	case $1 in
		-f*|--file*)
		DATA_FILE=$2
		;;               
		*)
		echo "Unknow option: $1. Exiting the script."
		exit 2
		;;
	esac
	shift 2
done

echo "--------------------------------------------"
echo "Checkout tool started"
echo "--------------------------------------------"

if [ ! -e "$DATA_FILE" ] ; then
        echo "Property file $DATA_FILE doesn't exist. Please provide valid path by specyfing -f option"
        echo ""
        exit
fi

source $DATA_FILE
verifyIwdCliDirectory

verifySCOCredentials

OPTIONS="\"dest\":\"$MIGRATION_DEST\", \"sco_hostname\":\"$SCO_HOSTNAME\",
\"sco_user\":\"$SCO_USER\", \"sco_password\":\"$SCO_PASSWORD\""

if [ -z "$VMWARE_REPOSITORY" ] || [ -z "$VMWARE_DATASTORE" ] ; then
	echo "Check-Out has been set to \"yes\" but required parameters are missing. Please verify your data file $DATA_FILE"
	exit 1
fi

OPTIONS="$OPTIONS, \"vmware_repository\":\"$VMWARE_REPOSITORY\", \"vmware_datastore\":\"$VMWARE_DATASTORE\""
OPTIONS="{$OPTIONS}"		
$IWD_CLI/bin/deployer -h $SCO_HOSTNAME -u $SCO_USER -p $SCO_PASSWORD -f $CHECKOUT_FILE -d "$OPTIONS"


exit 0