#!/bin/bash

############################################################################################
# COPYRIGHT LICENSE:  This utility is owned by IBM and is provided in source code form. 
# You may copy and use (but not modify)  the utility  without payment to IBM for the 
# purposes of helping you to migrate your data from an IBM Workload Deployer product to
# another IBM product. Notwithstanding anything to the contrary,  IBM PROVIDES THE UTILITY
# ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING,
# BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY, SATISFACTORY
# QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND ANY WARRANTY OR CONDITION OF
# NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL
# OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR OPERATION OF THE UTLITY.  
# IBM MAY PROVIDE LIMITED SUPPORTFOR THE UTLITY, BUT IBM HAS NO OBLIGATION TO PROVIDE
# MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE UTLITITY.
###########################################################################################

SQL_FILE="migration.sql"
timestamp=$(date +%s)
LOG_FILE="UpdateIwdDatabase-${timestamp}.log"

while [ $# -ne 0 ]
do
	case $1 in
		-f*|--file*)
    	SQL_FILE=$2
		;;               
		*)
		;;
	esac
	shift 2
done

echo "Updating IWD database. Using $SQL_FILE"
if [ ! -e "$SQL_FILE" ] ; then
        echo "SQL script $SQL_FILE doesn't exists. Please provide valid path by specyfing -f option"
        exit
fi

echo "Logging to file $LOG_FILE"
echo "Updating IWD database. Using $SQL_FILE" > $LOG_FILE

db2 connect to RAINMAKE >> $LOG_FILE
db2 +c -tvf $SQL_FILE >> $LOG_FILE
re=$?
if [ "$re" -eq "0" ] ; then
	echo "All sql statements completed successfully. Commiting changes" >> $LOG_FILE 
	db2 "commit" >> $LOG_FILE 
	echo "Completed successfully"
	exit 0
else
	echo "There was some errors while running $SQL_FILE script. Rollbacking changes" >> $LOG_FILE
	db2 "rollback" >> $LOG_FILE
	echo "Completed with errors"
	exit 1
fi
