'''
COPYRIGHT LICENSE:  This utility is owned by IBM and is provided in source code form. 
You may copy and use (but not modify)  the utility  without payment to IBM for the 
purposes of helping you to migrate your data from an IBM Workload Deployer product to
another IBM product. Notwithstanding anything to the contrary,  IBM PROVIDES THE UTILITY
ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING,
BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY, SATISFACTORY
QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND ANY WARRANTY OR CONDITION OF
NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR OPERATION OF THE UTLITY.  
IBM MAY PROVIDE LIMITED SUPPORTFOR THE UTLITY, BUT IBM HAS NO OBLIGATION TO PROVIDE
MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE UTLITITY.
'''

import deployer
import subprocess
from scomigrator import rest, db2, constants

def recordAccessList(accessList, listObj=[]):
	for access in accessList :
		name,type = access.split('?')
		listObj.append({ "name" :name, "type" : type, "rights" : accessList[access] })
	return listObj
	
def createScoAccessList(accessList, resourceType, resourceId, host, port, username , password ):
	print "\tCreating access list"
	for access in accessList:		
		if access['type'] == "group":			
			groupName = access['name']
			if  groupName == constants.IWD_3107_DEFAULT_GROUP:
				print "\tGroup '%s' will be converted to project '%s'" % (constants.IWD_3107_DEFAULT_GROUP,constants.SCO_DEFAULT_PROJECT)
				groupName = constants.SCO_DEFAULT_PROJECT
			groupList = filter(lambda group: group.name == groupName, deployer.groups[groupName])				
			if len(groupList):
				group = groupList[0]				
				url = "/resources/"+ resourceType+ "/" + str(resourceId) + "/acl/group-" + str(group.id)
				response = rest.iwdRestRequest(host,port, username, password, "POST", url, "")				
				if response['status'] == rest.STATUS_CREATED and access['rights'] != deployer.READ_PERMISSION:					
					body = str(access['rights'])
					response = rest.iwdRestRequest(host,port, username, password, "PUT", url, body)
				print "\tProject %s added to access list of artifact" % (groupName)
			else:
				print "\tProject %s not found" % (groupName)
		else:
			print "\tUsers cannot be add to access list in SCO. Skipping user %s" % (access['name'])
					
def createPureAppAccessList(accessList, resourceType, resourceId, host, port, user , password ):
	print "Method not implemented ye"
	
def changeOwnership(resourceType,resourceId, newOwnerName,host, port, username , password ):
	print "Changing ownership"
	url = "/resources/"+ resourceType+ "/" + str(resourceId) 
	print "Looking for user %s " % (newOwnerName)
	userList = filter(lambda user: user.username == newOwnerName, deployer.users[newOwnerName])
	if len(userList) :
		print "User found"
		newOwnerId = userList[0].id
		body = "{\"ownerid\" : " + str(newOwnerId) + "}"
		response = rest.iwdRestRequest(host,port, username, password, "PUT", url, body)
		print "Response %s %s" % (str(response['status']),response['response'])
		
#	url = "/resources/"+ resourceType+ "/" + str(resourceId) + "/acl/group-" + str(group.id)
#	response = rest.iwdRestRequest(host,port, username, password, "POST", url, "")
	
def changeOwnerRights(resourceType, resourceId, oldOwnerId, newOwnerName, db2Host, db2User):
	userList = filter(lambda user: user.username == newOwnerName, deployer.users[newOwnerName])
	if len(userList) :
		print "User found"
		newOwnerId = userList[0].id
		db2.changeUserAccessRightsToResource(resourceType, resourceId, oldOwnerId, newOwnerId, db2Host, db2User)
		
	
def _addGroupAccessToScoResource(resourceType, resourceId, host, port, username , password):
	return None