'''
COPYRIGHT LICENSE:  This utility is owned by IBM and is provided in source code form. 
You may copy and use (but not modify)  the utility  without payment to IBM for the 
purposes of helping you to migrate your data from an IBM Workload Deployer product to
another IBM product. Notwithstanding anything to the contrary,  IBM PROVIDES THE UTILITY
ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING,
BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY, SATISFACTORY
QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND ANY WARRANTY OR CONDITION OF
NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR OPERATION OF THE UTLITY.  
IBM MAY PROVIDE LIMITED SUPPORTFOR THE UTLITY, BUT IBM HAS NO OBLIGATION TO PROVIDE
MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE UTLITITY.
'''

import deployer
import subprocess
import codecs
import os
import shutil
import traceback
from scomigrator import constants

def createMigrationSql(dest):
	print "Creating migration sql script ..."
	if os.path.exists(constants.DB2_UPDATE_SQLSCRIPT_PATH):
		shutil.copyfile(constants.DB2_UPDATE_SQLSCRIPT_PATH, dest)
		os.remove(constants.DB2_UPDATE_SQLSCRIPT_PATH)
		print "Created. Path to file: %s" % (dest)		
	else:
		print "Migration SQL script wasn't generated while import process. Skipping"
	
def _getTableRelatedToResource(resourceType):
	try:
		tableName = constants.DB2_RESOURCE_TO_TABLE[resourceType]
		return tableName
	except Exception, err:
		print '\tUnable to get table name related to resource: %s' %(resourceType)
		return None

# Method responsible for writing sql statements responsible for changing owner of a resource
def changeResourceOwner(resourceType,resourceId, currentOwnerId, newOwnerName):
#	print "Changing owner of the resource with type: %s and id: %s " % (resourceType,resourceId)
	userList = filter(lambda user: user.username == newOwnerName, deployer.users[newOwnerName])
	if len(userList) :
		print "\tAdding user %s to sql script for owner update..." % (newOwnerName)
		newOwnerId = userList[0].id
		tableName = _getTableRelatedToResource(resourceType)
		if tableName is None :
			print "\tUnable to change the owner of the resource"
			return 1
		lines = []
	#	lines.append("db2 connect to" + constants.DB2_RAINMAKER_DB)		
		lines.append(_getUpdateOwnerOfResourceString(tableName,resourceId,newOwnerId) + "\n" )
		lines.append(_getUpdateAclOwnerOfResourceString(tableName, resourceId, currentOwnerId, newOwnerId) + "\n")
		if tableName == 'templates':
			lines.append(_getUpdateOwnerOfPartResource(resourceId,newUserId) + "\n")
	#	lines.append("db2 \"commit\"")		
		f = codecs.open(os.path.join(constants.DB2_UPDATE_SQLSCRIPT_PATH), 'ab', 'utf-8')
		try:
			f.writelines(lines)
			f.write("\n")
			print "\tUser added"
		finally:
			f.close()
			
# Not implemented
# Method for changing owner of artifact interactively via ssh			
def changeResourceOwnerViaRest(resourceType,resourceId, currentOwnerId, newOwnerName, db2Host, db2User):
	return None
		
def _getUpdateAclOwnerOfResourceString(resourceType, resourceId, oldUserId, newUserId):
	sqlString = "UPDATE ACCESSCONTROLS SET userid=" + str(newUserId) + " WHERE resourcename = '" + resourceType + "' and resourceid = " + str(resourceId) + " and userid = " + str(oldUserId) + " and isgroup = 0 ;"
	return sqlString
	
def _getUpdateOwnerOfResourceString(tableName, resourceId, newOwnerId):
	sqlString = "UPDATE " + tableName + " SET ownerid = " + str(newOwnerId) + " WHERE id = " + str(resourceId) + " ;"
	return sqlString
	
# When you change owner of template (virtual image), 
# there is also need to update PART2S table. 
# Parts are related to templates and its owner has to be also changed 
def _getUpdateOwnerOfPartResource(templateId, newOwnerId):
	sqlString = "UPDATE PART2S SET ownerid=" + str(newUserId) + " WHERE templateId = " + templateId + " ;"
	return sqlString

	
def _runSqlViaSsh(sqlCmds, db2Host, db2User):
	print "\tRunning sql command on %s" % (db2Host)
	print "\tSql command : %s" %  (sqlCmd)
	tmpSqlScript = '/tmp/run_sql.sh'
	cmdString = "su - " + db2User + " -c \"db2 connect to " + dbName + "; db2 " + sqlCmd + "\""
	chmodCmd = ["chmod", "+x",  tmpSqlScript]
	runCmd = [ "ssh", db2Host, "\""+ tmpSqlScript + "\""]
	scpCmd = ["scp",  tmpSqlScript, db2Host + ":" + tmpSqlScript]	
	f = codecs.open(os.path.join(tmpSqlScript), 'wb', 'utf-8')
	try:
		f.write("#!/bin/bash\n")
		f.write(cmdString)
	finally:
		f.close()
	subprocess.call(chmodCmd,stdout=subprocess.PIPE)
	subprocess.call(scpCmd,stdout=subprocess.PIPE)		
	child = subprocess.Popen(runCmd,stdout=subprocess.PIPE)
	output = child.communicate()[0]
	rc = child.returncode
	if rc == 0 or rc == '0':
		print "\tSql successfull"
	else:
		print "\tSql failed"
	rmString = "ssh " + db2Host + " \"rm -f "+ tmpSqlScript + "\""
	subprocess.call(rmString,shell=True)		
	os.remove(tmpSqlScript)
	return rc
	