'''
COPYRIGHT LICENSE:  This utility is owned by IBM and is provided in source code form. 
You may copy and use (but not modify)  the utility  without payment to IBM for the 
purposes of helping you to migrate your data from an IBM Workload Deployer product to
another IBM product. Notwithstanding anything to the contrary,  IBM PROVIDES THE UTILITY
ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING,
BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY, SATISFACTORY
QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND ANY WARRANTY OR CONDITION OF
NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR OPERATION OF THE UTLITY.  
IBM MAY PROVIDE LIMITED SUPPORTFOR THE UTLITY, BUT IBM HAS NO OBLIGATION TO PROVIDE
MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE UTLITITY.
'''

from scomigrator import rest, roles

RESOURCE_TYPE="projects"

def createProject(authObj, projectRestObj):	
	response = rest.createKeystoneResource(authObj, RESOURCE_TYPE, projectRestObj)
	if response['status'] in rest.ERROR_STATUSES:
		print "Error while creating a project: %s. Response status is %s" % (projectRestObj['project']['name'],response)	
		return None
	else:
		return response['response']['project']

def getProject(authObj, projectName):
	return rest.getKeystoneResource(authObj, RESOURCE_TYPE, projectName)	

def addRoleForUserToProject(authObj, projectId, userName, roleName):	
	from scomigrator import users
	user = users.getUser(authObj, userName)
	if user is None:
		print "Specified User does not exists. Skipping"
		return 2
	role = roles.getRole(authObj, roleName)			
	url = "/" + authObj['endpointId'] + "/v3/projects/" + projectId + "/users/" + user['id'] + "/roles/" + role['id']	
	status = rest.putKeystoneRequest(authObj, url)	
	if status == rest.STATUS_PUT_SUCCESS:
		return 0
	else:
		return 1